﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using FGCS.Core.Models;
using FGCS.Core.ViewModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace FGCS.Core.Controllers
{
    public class UserController :ValuesController
    {
        #region 用户登录
        /// <summary>
        /// 用户登录
        /// </summary>
        /// <param name="login"></param>
        /// <returns></returns>
        [HttpPost]
        public User Login([FromBody]Login login)
        {
            User u = to.User.FirstOrDefault(f => f.UPhone == login.Account && f.UPassword == login.Password);
            if (u == null)
            {
                return null;
            }
            return u;
        }
        #endregion

        #region 用户注册
        /// <summary>
        /// 用户注册
        /// </summary>
        /// <param name="user"></param>
        /// <returns></returns>
        [HttpPost]
        public bool ZhuCe([FromBody]User user)
        {
            try
            {
                User u = new User();
                u.UName = user.UName;
                u.UPhone = user.UPhone;
                u.UAccount = user.UAccount;
                u.UPassword = user.UPassword;
                u.URegisterDate = DateTime.Now.ToLocalTime();
                u.UCategory = user.UCategory;
                to.Entry(u).State = EntityState.Added;
                to.SaveChanges();
                return true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return false;
            }
        }
        #endregion

        #region 所有状态为运营的店铺
        /// <summary>
        /// 所有状态为运营的店铺
        /// </summary>
        /// <returns></returns>
        public List<Merchant> ShowMerchant()
        {
            return to.Merchant.Where(w => w.MState == true).ToList();
        }
        #endregion

        #region 绑定客户对该店铺消费记录
        /// <summary>
        /// 绑定客户对该店铺消费记录
        /// </summary>
        /// <param name="delete"></param>
        /// <returns></returns>
        [HttpPost]
        public List<OrderVM> GetOrders([FromBody]DeleteSpecificationListVM delete)
        {
            string sql = @"select o.*,u.U_Name, m.M_Name,d.D_TypeDetailed from [Order] as o
inner join [User] as u on u.U_Id = o.U_Id
inner join Merchant as m on o.MU_Id = m.MU_Id
inner join Dictionary as d on o.O_Id  = d.O_Id
where o.MU_Id = " + delete.id + " and o.U_Id = " + delete.name + "";
            List<OrderVM> vm = new List<OrderVM>();
            DataTable table = TOHepler.GetData(sql);
            foreach (DataRow i in table.Rows)
            {
                vm.Add(new OrderVM()
                {
                    OId = Convert.ToInt32(i.ItemArray[0]),
                    UId = Convert.ToInt32(i.ItemArray[1]),
                    UName = Convert.ToString(i.ItemArray[7]),
                    MName = Convert.ToString(i.ItemArray[8]),
                    DTypeDetailed = Convert.ToString(i.ItemArray[9]),
                    MUId = Convert.ToInt32(i.ItemArray[2]),
                    OText = Convert.ToString(i["O_Text"]),
                    OAddresss = Convert.ToString(i["O_Addresss"]),
                    OPrice = Convert.ToDecimal(i.ItemArray[6]),
                    ORegister = i.ItemArray[5].ToString().Substring(0, 16),
                });
            }
            return vm.OrderByDescending(o => o.OId).ToList();
        }
        #endregion

        #region 根据店铺绑定商品详情
        /// <summary>
        /// 根据店铺绑定商品详情
        /// </summary>
        /// <param name="id">店铺</param>
        /// <returns></returns>
        [HttpPost]
        public List<CommodityDetailsVM> GetCommodityDetails([FromBody]DeleteSpecificationListVM d)
        {
            List<CommodityDetailsVM> vm = new List<CommodityDetailsVM>();
            List<CommodityDetails> commodities = to.CommodityDetails.Where(w => w.MuId == d.id).ToList();
            foreach (CommodityDetails i in commodities)
            {
                CommodityDetailsVM c = new CommodityDetailsVM();
                c.CdId = i.CdId;
                c.CtId = i.CtId;
                c.MuId = i.MuId;
                c.CdName = i.CdName;
                c.CdPrice = i.CdPrice;
                c.CdPicture = i.CdPicture;
                c.CdDescribe = i.CdDescribe;
                c.CdState = i.CdState;
                c.CdRecommend = i.CdRecommend;
                c.CdSum = i.CdSum;
                CommoditySpecificationDictionary dictionary = to.CommoditySpecificationDictionary.FirstOrDefault(f => f.CdId == i.CdId);
                ShoppingTrolley shopping = to.ShoppingTrolley.FirstOrDefault(f => f.CdId == i.CdId && f.UId == Convert.ToInt32(d.name));
                c.s = shopping == null ? "" : shopping.StSum.ToString();
                c.x = dictionary == null ? false : true;
                foreach (Dictionary l in to.Dictionary.Where(w => w.CdId == i.CdId && w.DTypeDetailed != ""))
                {
                    CommodityDictionaryVM com = new CommodityDictionaryVM();
                    com.id = l.DId;
                    com.name = l.DTypeDetailed;
                    c.c.Add(com);
                }
                vm.Add(c);
            }
            return vm;
        }
        #endregion

        #region 绑定购物车
        /// <summary>
        /// 绑定购物车
        /// </summary>
        /// <param name="id">用户</param>
        /// <returns></returns>
        [HttpGet("{id}")]
        public List<ShoppingTrolley> GetShoppingTrolleys(int id)
        {
            return to.ShoppingTrolley.Where(w => w.UId == id).ToList();
        }
        #endregion

        #region 添加购物车
        /// <summary>
        /// 添加购物车
        /// </summary>
        /// <param name="s">购物车</param>
        /// <returns></returns>
        [HttpPut("{id}")]
        public List<ShoppingTrolley> AddShoppingTrolley(int id, [FromBody]ShoppingTrolley s)
        {
            int tro = 0;
            List<ShoppingTrolley> list = to.ShoppingTrolley.Where(w => w.UId == s.UId).ToList();
            ShoppingTrolley shopping = list.FirstOrDefault(f => f.CdId == s.CdId && f.StCommodityDetailsName.Equals(s.StCommodityDetailsName));
            if (shopping != null)
            {

                // 减去单品购物车
                if (s.StPicture.Equals("减"))
                {
                    if (s.StSum == 1)
                    {
                        to.Entry(shopping).State = EntityState.Deleted;
                        to.SaveChanges();
                    }
                    else
                    {
                        decimal dec = shopping.StPrice / shopping.StSum;
                        shopping.StSum -= 1;
                        shopping.StPrice -= dec;
                        to.Entry(shopping).State = EntityState.Modified;
                        to.SaveChanges();
                    }
                }
                // 添加购物车单品数量一次添加一个
                else
                {
                    if (shopping.StSpecification != "标准")
                    {
                        List<CommoditySpecificationDictionary> dic = to.CommoditySpecificationDictionary.Where(w => w.CdId == shopping.CdId).ToList();
                        if (dic.Count != 0)
                        {
                            foreach (CommoditySpecificationDictionary odi in dic)
                            {
                                string str = odi.CsdType + "--" + odi.CsdTypeName + ".";
                                if (shopping.StSpecification.Equals(str) && shopping.StSum < odi.CsdTypeSum)
                                {
                                    tro++;
                                    decimal dec = shopping.StPrice / shopping.StSum;
                                    shopping.StSum += 1;
                                    shopping.StPrice += dec;
                                    to.Entry(shopping).State = EntityState.Modified;
                                    to.SaveChanges();
                                }
                            }
                            if (tro == 0)
                            {
                                ShoppingTrolley shoppingTrolley = new ShoppingTrolley();
                                shoppingTrolley.UId = s.UId;
                                shoppingTrolley.CdId = s.CdId;
                                shoppingTrolley.StDic = s.StDic;
                                shoppingTrolley.StCommodityDetailsName = s.StCommodityDetailsName;
                                shoppingTrolley.StSpecification = s.StSpecification;
                                if (s.StSum == 1)
                                {
                                    shoppingTrolley.StSum = 1;
                                }
                                else
                                {
                                    shoppingTrolley.StSum = id;
                                }
                                shoppingTrolley.StPicture = s.StPicture;
                                shoppingTrolley.StPrice = s.StPrice;
                                to.Entry(shoppingTrolley).State = EntityState.Added;
                                to.SaveChanges();
                            }
                        }
                    }
                    else
                    {
                        // 判断单品库存数量是否大于购物车单品数量
                        int? sum = to.CommodityDetails.FirstOrDefault(f => f.CdId == s.CdId).CdSum;
                        if (shopping.StSum < sum)
                        {
                            decimal dec = shopping.StPrice / shopping.StSum;
                            shopping.StSum += 1;
                            shopping.StPrice += dec;
                            to.Entry(shopping).State = EntityState.Modified;
                            to.SaveChanges();
                        }
                    }
                }
            }

            else
            {
                ShoppingTrolley shoppingTrolley = new ShoppingTrolley();
                shoppingTrolley.UId = s.UId;
                shoppingTrolley.CdId = s.CdId;
                shoppingTrolley.StDic = s.StDic;
                shoppingTrolley.StCommodityDetailsName = s.StCommodityDetailsName;
                shoppingTrolley.StSpecification = s.StSpecification;
                if (s.StSum == 1)
                {
                    shoppingTrolley.StSum = 1;
                }
                else
                {
                    shoppingTrolley.StSum = id;
                }
                shoppingTrolley.StPicture = s.StPicture;
                shoppingTrolley.StPrice = s.StPrice;
                to.Entry(shoppingTrolley).State = EntityState.Added;
                to.SaveChanges();
            }

            return to.ShoppingTrolley.ToList();
        }
        #endregion

        #region 清空购物车
        /// <summary>
        /// 清空购物车
        /// </summary>
        /// <param name="id">客户</param>
        /// <returns></returns>
        [HttpDelete("{id}")]
        public List<ShoppingTrolley> DeleteShoppingTroleyList(int id)
        {
            string sql = "delete from ShoppingTrolley where U_Id = " + id + "";
            TOHepler.ExecuteNonQuery(sql);
            return to.ShoppingTrolley.Where(w => w.UId == id).ToList();
        }
        #endregion

        #region 结算时更新单品库存
        /// <summary>
        /// 结算时更新单品库存
        /// </summary>
        /// <param name="id">客户</param>
        /// <returns></returns>
        [HttpDelete("{id}")]
        public List<ShoppingTrolley> DeleteCommodityDetailsList(int id)
        {
            List<ShoppingTrolley> shopping = to.ShoppingTrolley.Where(w => w.UId == id).ToList();
            foreach (ShoppingTrolley i in shopping)
            {
                if (i.StSpecification == "标准")
                {
                    CommodityDetails d = to.CommodityDetails.FirstOrDefault(f => f.CdId == i.CdId);
                    d.CdSum -= i.StSum;
                    to.Entry(d).State = EntityState.Modified;
                    to.SaveChanges();
                }
            }
            foreach (ShoppingTrolley i in shopping)
            {
                List<CommoditySpecificationDictionary> dic = to.CommoditySpecificationDictionary.Where(w => w.CdId == i.CdId).ToList();
                if (dic.Count != 0)
                {
                    foreach (CommoditySpecificationDictionary s in dic)
                    {
                        string str = s.CsdType + "--" + s.CsdTypeName + ".";
                        if (i.StSpecification.Equals(str))
                        {
                            CommoditySpecificationDictionary com = to.CommoditySpecificationDictionary.FirstOrDefault(f => f.CsdId == s.CsdId);
                            com.CsdTypeSum -= i.StSum;
                            to.Entry(com).State = EntityState.Modified;
                            to.SaveChanges();
                        }
                    }
                }
            }
            string sql = "delete from ShoppingTrolley where U_Id = " + id + "";
            TOHepler.ExecuteNonQuery(sql);
            return to.ShoppingTrolley.Where(w => w.UId == id).ToList();
        }
        #endregion

        #region 添加订单
        /// <summary>
        /// 添加订单
        /// </summary>
        /// <param name="o">订单数据</param>
        [HttpPost]
        public int AddOrders([FromBody]OrderVM o)
        {
            int id = 0;
            Order order = new Order();
            order.UId = o.UId;
            order.MuId = o.MUId;
            order.OAddresss = o.OAddresss;
            order.OText = o.OText;
            order.ORegister = DateTime.Now.ToLocalTime();
            order.OPrice = o.OPrice;
            to.Entry(order).State = EntityState.Added;
            to.SaveChanges();
            Dictionary dic = new Dictionary();
            dic.DType = "订单状态";
            dic.DTypeDetailed = "未完成";
            dic.DState = true;
            dic.DText = "订单";
            dic.CdId = null;
            dic.MuId = o.MUId;
            foreach (var i in to.Order.Where(w => w.UId == o.UId))
            {
                if (id < i.OId)
                {
                    id = i.OId;
                }
            }
            dic.OId = id;
            to.Entry(dic).State = EntityState.Added;
            to.SaveChanges();
            return order.OId;
        }
        #endregion

        #region 修改订单状态
        /// <summary>
        /// 修改订单状态
        /// </summary>
        /// <param name="id">订单编号</param>
        /// <returns></returns>
        [HttpPost]
        public List<OrderVM> UpdateOrder([FromBody]DeleteSpecificationListVM update)
        {
            Dictionary dic = to.Dictionary.FirstOrDefault(f => f.OId == update.id && f.DText == "订单");
            dic.DTypeDetailed = "已完成";
            to.Entry(dic).State = EntityState.Modified;
            to.SaveChanges();
            DeleteSpecificationListVM d = new DeleteSpecificationListVM();
            d.id = Convert.ToInt32(dic.MuId);
            d.name = update.name;
            return GetOrders(d);
        }
        #endregion

        #region 绑定客户数据
        /// <summary>
        /// 绑定客户数据
        /// </summary>
        /// <param name="id">客户</param>
        /// <returns></returns>
        [HttpGet("{id}")]
        public User GetUser(int id)
        {
            return to.User.FirstOrDefault(f => f.UId == id);
        }
        #endregion

        #region 删除收货地址
        /// <summary>
        /// 删除收货地址
        /// </summary>
        /// <param name="delete">对象</param>
        /// <returns></returns>
        [HttpPost]
        public List<Uaddress> DeleteUaddress([FromBody]DeleteSpecificationListVM delete)
        {
            string sql = @"delete from Uaddress where UA_Id = " + delete.id + "";
            TOHepler.ExecuteNonQuery(sql);
            return GetUaddresses(Convert.ToInt32(delete.name));
        }
        #endregion

        #region 修改收货地址
        /// <summary>
        /// 修改收货地址
        /// </summary>
        /// <param name="delete">对象</param>
        /// <returns></returns>
        [HttpPut("{id}")]
        public List<Uaddress> UpdateUaddress(int id, [FromBody]Uaddress u)
        {
            try
            {
                Uaddress uaddress = to.Uaddress.FirstOrDefault(f => f.UaId == id);
                uaddress.UId = u.UId;
                uaddress.UaPhone = u.UaPhone;
                uaddress.UaName = u.UaName;
                uaddress.UaProvince = u.UaProvince;
                uaddress.UaCity = u.UaCity;
                uaddress.UaCityValue = u.UaCityValue;
                uaddress.UaDistrictValue = u.UaDistrictValue;
                uaddress.UaProvinceValue = u.UaProvinceValue;
                uaddress.UaDistrict = u.UaDistrict;
                uaddress.UaDetailedAddress = u.UaDetailedAddress;
                uaddress.UaState = u.UaState;
                to.Entry(uaddress).State = EntityState.Modified;
                to.SaveChanges();
                if (uaddress.UaState == true)
                {
                    foreach (Uaddress i in to.Uaddress.Where(w => w.UaId != uaddress.UaId))
                    {
                        Uaddress ua = to.Uaddress.FirstOrDefault(f => f.UaId == i.UaId);
                        ua.UaState = false;
                        to.Entry(ua).State = EntityState.Modified;
                        to.SaveChanges();
                    }
                }
                return GetUaddresses(Convert.ToInt32(u.UId));
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return GetUaddresses(Convert.ToInt32(u.UId));
            }

        }
        #endregion

        #region 添加收货地址
        /// <summary>
        /// 添加收货地址
        /// </summary>
        /// <param name="u"></param>
        /// <returns></returns>
        [HttpPost]
        public List<Uaddress> AddUaddress([FromBody]Uaddress u)
        {
            try
            {
                Uaddress uaddress = new Uaddress();
                uaddress.UId = u.UId;
                uaddress.UaPhone = u.UaPhone;
                uaddress.UaName = u.UaName;
                uaddress.UaProvince = u.UaProvince;
                uaddress.UaCityValue = u.UaCityValue;
                uaddress.UaDistrictValue = u.UaDistrictValue;
                uaddress.UaProvinceValue = u.UaProvinceValue;
                uaddress.UaCity = u.UaCity;
                uaddress.UaDistrict = u.UaDistrict;
                uaddress.UaDetailedAddress = u.UaDetailedAddress;
                uaddress.UaState = u.UaState;
                to.Entry(uaddress).State = EntityState.Added;
                to.SaveChanges();
                if (uaddress.UaState == true)
                {
                    foreach (Uaddress i in to.Uaddress.Where(w => w.UaId != uaddress.UaId))
                    {
                        Uaddress ua = to.Uaddress.FirstOrDefault(f => f.UaId == i.UaId);
                        ua.UaState = false;
                        to.Entry(ua).State = EntityState.Modified;
                        to.SaveChanges();
                    }
                }
            }
            catch (Exception)
            {
                return to.Uaddress.Where(w => w.UId == u.UId).ToList();
            }
            return to.Uaddress.Where(w => w.UId == u.UId).ToList();
        }
        #endregion

        #region 绑定订单详情
        /// <summary>
        /// 绑定订单详情
        /// </summary>
        /// <param name="id">订单编号</param>
        /// <returns></returns>
        [HttpGet("{id}")]
        public List<OrderDetailedVM> GetOrderDetails(int id)
        {
            string sql = @"select o.*,c.CD_Name from OrderDetails as o
inner join CommodityDetails as c on o.CD_Id=c.CD_Id
where o.O_Id =" + id + "";
            List<OrderDetailedVM> o = new List<OrderDetailedVM>();
            DataTable table = TOHepler.GetData(sql);
            foreach (DataRow i in table.Rows)
            {
                o.Add(new OrderDetailedVM()
                {
                    CdId = Convert.ToInt32(i["CD_Id"]),
                    OdDic = Convert.ToString(i["OD_Dic"]),
                    OdSpecification = Convert.ToString(i["OD_Specification"]),
                    OdSubtotal = Convert.ToDecimal(i["OD_Subtotal"]),
                    OdSum = Convert.ToInt32(i["OD_Sum"]),
                    OdId = Convert.ToInt32(i["OD_Id"]),
                    OId = Convert.ToInt32(i["O_Id"]),
                    OName = Convert.ToString(i["CD_Name"]),
                });
            }
            return o;
        }
        #endregion

        #region 添加订单详情
        /// <summary>
        /// 添加订单详情
        /// </summary>
        /// <param name="delete">订单数据</param>
        [HttpPost]
        public void AddOrderDetails([FromBody]DeleteSpecificationListVM delete)
        {
            List<ShoppingTrolley> shoppings = to.ShoppingTrolley.Where(w => w.UId == delete.id).ToList();
            foreach (ShoppingTrolley i in shoppings)
            {
                OrderDetails order = new OrderDetails();
                order.OId = Convert.ToInt32(delete.name);
                order.CdId = i.CdId;
                order.OdSum = i.StSum;
                order.OdDic = i.StDic;
                order.OdSpecification = i.StSpecification;
                order.OdSubtotal = i.StPrice;
                to.Entry(order).State = EntityState.Added;
                to.SaveChanges();
            }
            //return to.Order.Where(w => w.UId == o.UId && w.MuId == o.MuId).ToList();
        }
        #endregion

        #region 绑定客户收货地址
        /// <summary>
        /// 绑定客户收货地址
        /// </summary>
        /// <param name="id">客户</param>
        /// <returns></returns>
        [HttpGet("{id}")]
        public List<Uaddress> GetUaddresses(int id)
        {
            return to.Uaddress.Where(w => w.UId == id).ToList();
        }
        #endregion
    }
}