﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using FGCS.Core.Models;
using FGCS.Core.ViewModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Newtonsoft.Json;

namespace FGCS.Core.Controllers
{
    public class WeChatController : ValuesController
    {
        /// <summary>
        /// 发起请求
        /// </summary>
        public static HttpClient httpClient = new HttpClient();

        #region 公众号的唯一标识
        /// <summary>
        /// 公众号的唯一标识
        /// </summary>
        /// <returns></returns>
        private app GetApp()
        {
            app a = new app();
            a.appid = "wxfbff9ce4eb977078";
            a.appsecret = "5c8f7b69dfe46834e5da32dd6d4fe855";
            return a;
        }
        #endregion

        #region 用户授权并获取用户信息
        /// <summary>
        /// 用户授权并获取用户信息
        /// </summary>
        /// <param name="delete"></param>
        [HttpPost]
        public User GetCode([FromBody]DeleteSpecificationListVM delete)
        {
            app a = GetApp();
            string refresh = "";
            string openid = "";
            string access = "";
            string code = MidStrEx(delete.name);
            //请求微信接口返回 code值, 网页授权access_token的值,
            string url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=" + a.appid + "&secret=" + a.appsecret + "&code=" + code + "&grant_type=authorization_code";
            var responseStr = httpClient.GetAsync(url).Result.Content.ReadAsStringAsync().Result;
            var obj = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseStr);
            foreach (var i in obj)
            {
                if (i.Key == "refresh_token")
                {
                    refresh = i.Value;
                    continue;
                }
                if (i.Key == "access_token")
                {
                    access = i.Value;
                    continue;
                }
                if (i.Key == "openid")
                {
                    openid = i.Value;
                    continue;
                }
            }
            //string refresh_token = "https://api.weixin.qq.com/sns/oauth2/refresh_token?appid=" + a.appid + "&grant_type=refresh_token&refresh_token=REFRESH_TOKEN";
            string url1 = "https://api.weixin.qq.com/sns/userinfo?access_token=" + access + "&openid=" + openid + "&lang=zh_CN";
            var user = httpClient.GetAsync(url1).Result.Content.ReadAsStringAsync().Result;
            WeChant w = JsonConvert.DeserializeObject<WeChant>(user);
            Console.WriteLine(w);
            try
            {
                User users = to.User.FirstOrDefault(f => f.UAccount == "opuietz63h-GpJC9PsPFUkZmvoks");
                if (users == null)
                {
                    //添加消费者
                    User u = new User();
                    u.UName = w.nickname;//微信用户昵称
                    u.UGender = w.sex;//微信用户性别
                    u.UPhone = null;
                    u.UAccount = w.openid;//微信用户openid
                    u.UPassword = null;
                    u.URegisterDate = DateTime.Now.ToLocalTime();
                    u.UCategory = true;//true为消费者,false为商家
                    to.Entry(u).State = EntityState.Added;
                    to.SaveChanges();
                    return u;
                }
                else
                {
                    return users;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return null;
            }
        }
        #endregion

        #region 校验是否数据库是否存在改用户
        /// <summary>
        /// 校验是否数据库是否存在改用户
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public User IsInsertWeChat([FromBody]DeleteSpecificationListVM delete)
        {
            AttributeListVM d = new AttributeListVM();
            string code = MidStrEx(delete.name);//获取url中的code值
            if (code == "")
            {
                return null;
            }
            app a = GetApp();
            string openid = "";
            string access = "";
            string url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=" + a.appid + "&secret=" + a.appsecret + "&code=" + code + "&grant_type=authorization_code";
            var responseStr = httpClient.GetAsync(url).Result.Content.ReadAsStringAsync().Result;
            var obj = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseStr);
            foreach (var i in obj)
            {
                if (i.Key == "openid")
                {
                    openid = i.Value;
                    continue;
                }
                if (i.Key == "access_token")
                {
                    access = i.Value;
                    continue;
                }
            }
            User u = to.User.FirstOrDefault(f => f.UAccount == openid);
            if (u == null)
            {
                return null;
            }
            else
            {
                return u;
            }
            //app a = GetApp();
            //string result1 = WebUtility.UrlEncode("http://520bd2d0.nat123.cc");
            //string snsapi_base = string.Format("https://open.weixin.qq.com/connect/oauth2/authorize?appid={0}&redirect_uri={1}&response_type=code&scope=snsapi_base&state=123#wechat_redirect"
            //    , a.appid, result1);
            //var var = httpClient.GetAsync(snsapi_base).Result.Content.ReadAsStringAsync().Result;
            //var obj = JsonConvert.DeserializeObject<Dictionary<string, string>>(var);
            //Console.WriteLine(obj);
            ////string snsapi_userinfo = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wxf0e81c3bee622d60&redirect_uri=http%3A%2F%2Fnba.bluewebgame.com%2Foauth_response.php&response_type=code&scope=snsapi_userinfo&state=STATE#wechat_redirect";
        }
        #endregion

        #region 截取url中的code值
        /// <summary>
        /// 截取url中的code值
        /// </summary>
        /// <param name="sourse"></param>
        /// <param name="startstr"></param>
        /// <param name="endstr"></param>
        /// <returns></returns>
        public static string MidStrEx(string sourse, string startstr = "?code=", string endstr = "&state=")
        {
            string result = string.Empty;
            int startindex, endindex;
            try
            {
                startindex = sourse.IndexOf(startstr);
                if (startindex == -1)
                    return result;
                string tmpstr = sourse.Substring(startindex + startstr.Length);
                endindex = tmpstr.IndexOf(endstr);
                if (endindex == -1)
                    return result;
                result = tmpstr.Remove(endindex);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            return result;
        }
        #endregion

        #region 获取access_token值,并调用获取微信用户信息方法
        /// <summary>
        /// 获取access_token值
        /// </summary>
        /// <param name="appid">第三方用户唯一凭证</param>
        /// <param name="appsecret">应用密钥</param>
        /// <returns>access_token</returns>string appid, string appsecret
        public string GetAccess_Token()
        {
            app a = GetApp();
            string access_out = "";//全局接口凭证
            // 调用access_token接口获取全局唯一接口调用凭证
            string access_token = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" + a.appid + "&secret=" + a.appsecret + "";
            var responseStr = httpClient.GetAsync(access_token).Result.Content.ReadAsStringAsync().Result;
            var obj = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseStr);
            foreach (var i in obj)
            {
                if (i.Key == "access_token")
                {
                    access_out = i.Value;
                }
            }
            return access_out;
        }
        #endregion

        #region 此方法可实现自定义菜单，并且跳转网页授权
        /// <summary>
        /// 此方法可实现自定义菜单
        /// Post请求微信接口
        /// </summary>
        /// <param name="data">菜单数据对象</param>string data
        public void PostMenu()
        {
            // 读取json 文件
            //Menu menu = JsonConvert.DeserializeObject<Menu>(data);
            //Console.WriteLine(menu);
            //string json = "";
            //using (StreamReader r = new StreamReader("application.json"))
            //{
            //    json = r.ReadToEnd();
            //    Menu menu = JsonConvert.DeserializeObject<Menu>(json);
            //    Console.WriteLine(menu);
            //}
            //string data1 = json.Replace("\r\n", "").Trim();
            string result1 = WebUtility.UrlEncode("http://270bf0d2.nat123.cc/#/");
            app a = GetApp();
            string access_token = GetAccess_Token();
            string url = "https://api.weixin.qq.com/cgi-bin/menu/create?access_token=" + access_token + "";
            string data = "{" +
                "\"button\":[" +
               "{\"name\":\"功能\"," +
               "\"type\":\"click\"," +
               "\"key\":\"V1001_ZhongQiu\"" +
               "}" +
                ",{\"name\":\"菜单功能\"," +
                "\"sub_button\":[" +
                   "{\"type\":\"view\"," +
                   "\"name\":\"微信h\"," +
                   //"\"url\":\"http://520bd2d0.nat123.cc\"," +
                   //"\"url\":\"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + a.appid + "&redirect_uri=" + result1 + "&response_type=code&scope=snsapi_userinfo&state=STATE#wechat_redirect\"," +
                   "\"url\":\"https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + a.appid + "&redirect_uri=" + result1 + "&response_type=code&scope=snsapi_base&state=STATE#wechat_redirect\"," +
                   //"\"appid\":\"wxfbff9ce4eb977078\"," +
                   //"\"pagepath\":\"微信\"," +
                   "}" +
                "]" +
               "}" +
              "]" +
            "}";
            HttpContent httpContent = new StringContent(data);
            httpContent.Headers.ContentType = MediaTypeHeaderValue.Parse("application/json");
            httpContent.Headers.ContentType.CharSet = "utf-8";
            var responseStr = httpClient.PostAsync(url, httpContent).Result.Content.ReadAsStringAsync().Result;
            var obj = JsonConvert.DeserializeObject<Dictionary<string, string>>(responseStr);
        }
        #endregion

        #region 获取微信用户信息
        /// <summary>
        /// 获取微信用户信息
        /// </summary>
        /// <param name="openid">string openid</param>
        /// <returns></returns>
        public WeChant GetUser()
        {
            string openid = "opuietz63h-GpJC9PsPFUkZmvoks";//本次登录用户微信Id
            string access_out = GetAccess_Token();
            string url = "https://api.weixin.qq.com/cgi-bin/user/info?access_token=" + access_out + "&openid=" + openid + "&lang=zh_CN";
            var responseStr = httpClient.GetAsync(url).Result.Content.ReadAsStringAsync().Result;
            WeChant w = JsonConvert.DeserializeObject<WeChant>(responseStr);
            return w;
        }
        #endregion

        #region 验证微信签名
        /// <summary>
        /// 验证微信签名
        /// </summary>
        /// * 将token、timestamp、nonce三个参数进行字典序排序
        /// * 将三个参数字符串拼接成一个字符串进行sha1加密
        /// * 开发者获得加密后的字符串可与signature对比，标识该请求来源于微信。
        /// <param name="signature">微信加密签名，signature结合了开发者填写的token参数和请求中的timestamp参数、nonce参数。</param>
        /// <param name="timestamp">时间戳</param>
        /// <param name="nonce">随机数</param>
        /// <param name="echostr">随机字符串</param>
        /// <param name="token"></param>
        /// <returns></returns>
        [HttpGet]
        public ActionResult WeChatCheck(string signature, string timestamp, string nonce, string echostr, string token)
        {
            string[] ArrTmp = { "123456", timestamp, nonce };//"123456"是你的token值
            Array.Sort(ArrTmp);
            string tmpStr = string.Join("", ArrTmp);
            var sha1 = HmacSha1Sign(tmpStr);
            if (sha1.Equals(signature))
            {
                return Content(echostr);
            }
            else
            {
                return null;
            }
        }
        #endregion

        #region HMAC_SHA1加密算法
        /// <summary>
        /// HMAC_SHA1加密算法
        /// </summary>
        /// <param name="str">加密字符串</param>
        /// <returns></returns>
        private string HmacSha1Sign(string str)
        {
            var a1 = System.Security.Cryptography.SHA1.Create();
            var a2 = a1.ComputeHash(Encoding.Default.GetBytes(str));
            string a3 = null;
            for (int i = 0; i < a2.Length; i++)
            {
                a3 += a2[i].ToString("x2");
            }
            return a3;
        }
        #endregion
    }
}