﻿using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace FGCS.Core.ViewModels
{
    /// <summary>
    /// 数据库交互
    /// </summary>
    public class TOHepler
    {
        private static readonly object obj = new object();
        private static TOHepler instance = null;
        public IConfigurationRoot Config { get; }
        private TOHepler()
        {
            var builder = new ConfigurationBuilder()
                .SetBasePath(Directory.GetCurrentDirectory())
                .AddJsonFile("appsettings.json", optional: false, reloadOnChange: true);
            Config = builder.Build();
        }
        public static TOHepler GetInstance()
        {
            if (instance == null)
            {
                lock (obj)
                {
                    if (instance == null)
                    {
                        instance = new TOHepler();
                    }
                }
            }
            return instance;
        }
        public static string GetConfig(string name)
        {
            return GetInstance().Config.GetSection(name).Value;
        }
        private static string CONNECTION_STRING = TOHepler.GetConfig("ConnectionStrings:DefaultConnection");
        private static string _conStr = CONNECTION_STRING;

        private static SqlConnection _ion;
        public static SqlConnection _Ion
        {
            get
            {
                if (_ion == null)
                    _ion = new SqlConnection(_conStr);
                if (_ion.State != ConnectionState.Open)
                    _ion.Open();
                return _ion;
            }
        }


        public static int ExecuteNonQuery(string sql)
        {
            SqlCommand and = _Ion.CreateCommand();
            and.CommandText = sql;
            try
            {
                return and.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return 0;
            }
            finally
            {
                and.Connection.Close();
            }
        }
        public static DataTable GetData(string sql)
        {
            SqlDataAdapter adapter = new SqlDataAdapter(sql, _conStr);
            DataSet set = new DataSet();
            adapter.Fill(set);
            return set.Tables[0];
        }
    }
}
